

%--------------------------------------------------------------------------
% File     : PUZ008-2 : TPTP v6.0.0. Released v1.0.0.
% Domain   : Puzzles
% Problem  : Missionaries and Cannibals
% Version  : Especial.
%            Theorem formulation : Procedural.
% English  : There are 3 missionaries, 3 cannibals, and a boat on the west
%            bank of a river. All wish to cross, but the boat holds
%            at most 2 people. If the cannibals ever outnumber the
%            missionaries on either bank of the river the outnumbered
%            missionaries will be eaten. Can they all safely cross the
%            river?  If so, how? (The boat cannot cross empty.)

% Refs     :
% Source   : [ANL]
% Names    : mission.ver2.in [ANL]

% Status   : Unsatisfiable
% Rating   : 0.12 v6.0.0, 0.00 v3.3.0, 0.33 v3.2.0, 0.00 v3.1.0, 0.11 v2.7.0, 0.00 v2.0.0
% Syntax   : Number of clauses     :   32 (   0 non-Horn;   2 unit;  32 RR)
%            Number of atoms       :   62 (   0 equality)
%            Maximal clause size   :    2 (   2 average)
%            Number of predicates  :    1 (   0 propositional; 3-3 arity)
%            Number of functors    :   10 (   6 constant; 0-2 arity)
%            Number of variables   :    0 (   0 singleton)
%            Maximal term depth    :    3 (   2 average)
% SPC      : CNF_UNS_EPR

% Comments :
%--------------------------------------------------------------------------
%----Moving cannibals only, west to east
cnf(bccc_mmm_to_cc_bmmmc,axiom,
    ( ~ banks(west(m(nz),c(nw)),east(m(nw),c(nz)),boatonwest)
    | banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatoneast) )).

cnf(bmmmcc_c_to_mmmc_cc,axiom,
    ( ~ banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatonwest)
    | banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatoneast) )).

cnf(bcc_mmmc_to_c_mmmcc,axiom,
    ( ~ banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatonwest)
    | banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatoneast) )).

cnf(bmmmc_cc_to_mmm_ccc,axiom,
    ( ~ banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatonwest)
    | banks(west(m(nw),c(nz)),east(m(nz),c(nw)),boatoneast) )).

cnf(bc_mmmcc_to_x_bmmmccc,axiom,
    ( ~ banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatonwest)
    | banks(west(m(nz),c(nz)),east(m(nw),c(nw)),boatoneast) )).

cnf(bmmmccc_x_to_mmmc_bcc,axiom,
    ( ~ banks(west(m(nw),c(nw)),east(m(nz),c(nz)),boatonwest)
    | banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatoneast) )).

cnf(bccc_mmm_to_c_bmmmcc,axiom,
    ( ~ banks(west(m(nz),c(nw)),east(m(nw),c(nz)),boatonwest)
    | banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatoneast) )).

cnf(bmmmcc_c_to_mmm_bccc,axiom,
    ( ~ banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatonwest)
    | banks(west(m(nw),c(nz)),east(m(nz),c(nw)),boatoneast) )).

cnf(bcc_mmmc_to_x_bmmmccc,axiom,
    ( ~ banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatonwest)
    | banks(west(m(nz),c(nz)),east(m(nw),c(nw)),boatoneast) )).

%----Moving cannibals only, east to west
cnf(cc_bmmmc_to_bccc_mmm,axiom,
    ( ~ banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatoneast)
    | banks(west(m(nz),c(nw)),east(m(nw),c(nz)),boatonwest) )).

cnf(c_bmmmcc_to_bcc_mmmc,axiom,
    ( ~ banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatoneast)
    | banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatonwest) )).

cnf(mmm_bccc_to_bmmmc_cc,axiom,
    ( ~ banks(west(m(nw),c(nz)),east(m(nz),c(nw)),boatoneast)
    | banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatonwest) )).

cnf(mmmcc_bc_to_bmmmccc_x,axiom,
    ( ~ banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatoneast)
    | banks(west(m(nw),c(nw)),east(m(nz),c(nz)),boatonwest) )).

cnf(mmmc_bcc_to_bmmmcc_c,axiom,
    ( ~ banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatoneast)
    | banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatonwest) )).

cnf(c_bmmmcc_to_bccc_mmm,axiom,
    ( ~ banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatoneast)
    | banks(west(m(nz),c(nw)),east(m(nw),c(nz)),boatonwest) )).

cnf(mmmc_bcc_to_bmmmccc_x,axiom,
    ( ~ banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatoneast)
    | banks(west(m(nw),c(nw)),east(m(nz),c(nz)),boatonwest) )).

cnf(mmm_bccc_to_bmmmcc_c,axiom,
    ( ~ banks(west(m(nw),c(nz)),east(m(nz),c(nw)),boatoneast)
    | banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatonwest) )).

%----Moving missionaries only, west to east
cnf(bmmmcc_c_to_mmcc_bmc,axiom,
    ( ~ banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatonwest)
    | banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatoneast) )).

cnf(bmc_mmcc_to_c_bmmmcc,axiom,
    ( ~ banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatonwest)
    | banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatoneast) )).

cnf(bmmmc_cc_to_mc_bmmcc,axiom,
    ( ~ banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatonwest)
    | banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatoneast) )).

cnf(bmmcc_mc_to_cc_bmmmc,axiom,
    ( ~ banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatonwest)
    | banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatoneast) )).

%----Moving missionaries only, east to west
cnf(c_bmmmcc_to_bmc_mmcc,axiom,
    ( ~ banks(west(m(nz),c(ny)),east(m(nw),c(nx)),boatoneast)
    | banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatonwest) )).

cnf(mmcc_bmc_to_bmmmcc_c,axiom,
    ( ~ banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatoneast)
    | banks(west(m(nw),c(nx)),east(m(nz),c(ny)),boatonwest) )).

cnf(cc_bmmmc_to_bmmcc_mc,axiom,
    ( ~ banks(west(m(nz),c(nx)),east(m(nw),c(ny)),boatoneast)
    | banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatonwest) )).

cnf(mc_bmmcc_to_bmmmc_cc,axiom,
    ( ~ banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatoneast)
    | banks(west(m(nw),c(ny)),east(m(nz),c(nx)),boatonwest) )).

%----Moving a missionary and a cannibal, west to east
cnf(bmmmccc_x_to_mmcc_bmc,axiom,
    ( ~ banks(west(m(nw),c(nw)),east(m(nz),c(nz)),boatonwest)
    | banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatoneast) )).

cnf(bmmcc_mc_to_mc_bmmcc,axiom,
    ( ~ banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatonwest)
    | banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatoneast) )).

cnf(bmc_mmcc_to_x_bmmmccc,axiom,
    ( ~ banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatonwest)
    | banks(west(m(nz),c(nz)),east(m(nw),c(nw)),boatoneast) )).

%----Moving a missionary and a cannibal, east to west
cnf(mc_bmmcc_to_bmmcc_mc,axiom,
    ( ~ banks(west(m(ny),c(ny)),east(m(nx),c(nx)),boatoneast)
    | banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatonwest) )).

cnf(mmcc_bmc_to_bmmmccc_x,axiom,
    ( ~ banks(west(m(nx),c(nx)),east(m(ny),c(ny)),boatoneast)
    | banks(west(m(nw),c(nw)),east(m(nz),c(nz)),boatonwest) )).

%----The problem to be solved
cnf(starting_configuration,hypothesis,
    ( banks(west(m(nw),c(nw)),east(m(nz),c(nz)),boatonwest) )).

cnf(prove_can_get_across,negated_conjecture,
    ( ~ banks(west(m(nz),c(nz)),east(m(nw),c(nw)),boatoneast) )).
